package main

import "container/heap"

type PriorityQueue []CoTree

func (p PriorityQueue) Len() int           { return len(p) }
func (p PriorityQueue) Less(i, j int) bool { return p[i].Unifications < p[j].Unifications }
func (p PriorityQueue) Swap(i, j int)      { p[i], p[j] = p[j], p[i] }

func (p *PriorityQueue) Push(x interface{}) {
	*p = append(*p, x.(CoTree))
}

func (p *PriorityQueue) Pop() interface{} {
	old := *p
	n := len(old)
	x := old[n-1]
	*p = old[:n-1]
	return x
}

func (p *PriorityQueue) PrintSolutions(max int) {
	for p.Len() > 0 {
		smin := heap.Pop(p).(CoTree)
		if smin.Unifications <= max {
			smin.printSolution()
		} else {
			heap.Push(p, smin)
			break
		}
	}
}
