package main

import (
	"fmt"
)

type Query []*Term

func (query Query) copyMap(substs TermMap) Query {
	queryNew := make([]*Term, len(query))
	for i, queryterm := range query {
		queryNew[i] = queryterm.Copy_(substs)
	}
	return queryNew
}

func (query Query) prettyString(pids PidMap) string {
	s := fmt.Sprintf("%s", query[0].prettyString(pids))
	for _, queryterm := range query[1:] {
		fmt.Sprintf("%s/n%s", s, queryterm.prettyString(pids))
	}
	return s + "\n"
}

func makeQuery(input string, pmap PnameMap) Query {
	pterms, err := ParseQuery(input)
	if err != nil {
		panic(err)
	}
	terms := make([]*Term, len(pterms))
	vmap := make(VnameMap)
	for i, pterm := range pterms {
		terms[i] = makeTermM(pterm, pmap, vmap)
	}
	return terms
}
