package main

import (
	"log"
	"runtime"
	"time"
)

func timeTrack(start time.Time) {
	elapsed := time.Since(start)
	var name string
	pc, _, _, ok := runtime.Caller(1)
	if ok {
		name = runtime.FuncForPC(pc).Name()
	}
	log.Printf("function %s took %s", name, elapsed)
}

func minIntSlice(values []int) int {
	var min int
	if len(values) > 0 {
		min = values[0]
	}
	for _, value := range values {
		if value < min {
			min = value
		}
	}
	return min
}
